import ts from "typescript";
import { arch } from "@plutolang/base";
import { ImportElement } from "./imports";
export interface VisitResult {
    resourceRelatInfos?: ResourceRelationshipInfo[];
    resourceVarInfos?: ResourceVariableInfo[];
}
export declare function concatVisitResult(...visitResults: (VisitResult | undefined)[]): VisitResult;
export interface ResourceVariableInfo {
    varName: string;
    resourceConstructInfo: ResourceConstructInfo;
}
export interface ResourceRelationshipInfo {
    fromVarName: string;
    toVarNames: string[];
    type: arch.RelatType;
    operation: string;
    parameters: ParameterInfo[];
}
export interface ResourceConstructInfo {
    constructExpression: string;
    importElements: ImportElement[];
    parameters?: ParameterInfo[];
    locations: Location[];
}
export interface ParameterInfo {
    name: string;
    resourceName?: string;
    expression: ts.Expression | undefined;
    order: number;
}
export interface Location {
    file: string;
    depth: number;
    start: string;
    end: string;
}
